"use strict";
var mount_1 = require('./mount');
var dom_1 = require('./nodes/dom');
var component_1 = require('./nodes/component');
var stream_1 = require('./nodes/stream');
var expression_1 = require('./nodes/expression');
var eventing_1 = require('./eventing');
exports.createEventStream = eventing_1.createEventStream;
exports.attachEventStream = eventing_1.attachEventStream;
exports.defaultNamespaceUriMap = {
    html: 'http://www.w3.org/1999/xhtml',
    svg: 'http://www.w3.org/2000/svg',
    xlink: 'http://www.w3.org/1999/xlink'
};
var StreamDom = (function () {
    function StreamDom(_a) {
        var _b = _a === void 0 ? {} : _a, _c = _b.document, document = _c === void 0 ? window.document : _c, _d = _b.eventNamespaceName, eventNamespaceName = _d === void 0 ? 'event' : _d, _e = _b.propertyNamespaceName, propertyNamespaceName = _e === void 0 ? 'property' : _e, _f = _b.namespaceUriMap, namespaceUriMap = _f === void 0 ? exports.defaultNamespaceUriMap : _f, _g = _b.defaultNamespaceName, defaultNamespaceName = _g === void 0 ? 'html' : _g;
        this.document = document;
        this.eventNamespaceName = eventNamespaceName;
        this.propertyNamespaceName = propertyNamespaceName;
        this.namespaceUriMap = namespaceUriMap;
        this.defaultNamespaceUri = this.getNamespaceUri(defaultNamespaceName);
        this.sharedRange = document.createRange();
    }
    StreamDom.prototype.getNamespaceUri = function (namespaceName) {
        if (namespaceName in this.namespaceUriMap) {
            return this.namespaceUriMap[namespaceName];
        }
        else {
            throw new Error("No namespace URI found for namespace name '" + namespaceName + "'");
        }
    };
    StreamDom.prototype.mount = function (streamDomNodeInit, domParentNode, domBeforeNode) {
        if (domBeforeNode === void 0) { domBeforeNode = null; }
        return mount_1.mount(this, streamDomNodeInit, domParentNode, domBeforeNode);
    };
    StreamDom.prototype.text = function (str) {
        return dom_1.text(this, str);
    };
    StreamDom.prototype.element = function (name, details) {
        return dom_1.element(this, name, details);
    };
    StreamDom.prototype.stream = function (children$) {
        return stream_1.stream(this, children$);
    };
    StreamDom.prototype.component = function (ComponentFactory, details) {
        return component_1.component(this, ComponentFactory, details);
    };
    StreamDom.prototype.expression = function (value) {
        return expression_1.expression(this, value);
    };
    return StreamDom;
}());
exports.StreamDom = StreamDom;
function configureStreamDom(config) {
    if (config === void 0) { config = {}; }
    return new StreamDom(config);
}
exports.configureStreamDom = configureStreamDom;
var streamDom = configureStreamDom();
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = streamDom;
