"use strict";
var eventing_1 = require('./eventing');
function mount(context, streamDomNodeInit, domParentNode, domBeforeNode) {
    if (domBeforeNode === void 0) { domBeforeNode = null; }
    var mounted$ = eventing_1.createMemoryEventStream();
    var destroy$ = eventing_1.createMemoryEventStream();
    var scope = {
        parentNamespaceUri: context.defaultNamespaceUri,
        mounted$: mounted$,
        destroy$: destroy$
    };
    var nodeDescriptor = streamDomNodeInit(scope);
    var domNode = nodeDescriptor.domNode;
    nodeDescriptor.insert(domParentNode, domBeforeNode);
    mounted$.next(null);
    return {
        nodeDescriptor: nodeDescriptor,
        dispose: function () {
            destroy$.next(null);
            nodeDescriptor.remove();
        }
    };
}
exports.mount = mount;
