"use strict";
var eventing_1 = require('../eventing');
function component(context, ComponentFactory, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.attributes, attributes = _c === void 0 ? [] : _c, _d = _b.children, children = _d === void 0 ? [] : _d;
    var properties = {};
    var eventStreams = {};
    var processAttributes = function (attributes) { return attributes.forEach(function (attributeDescriptor) {
        if (Array.isArray(attributeDescriptor)) {
            processAttributes(attributeDescriptor);
        }
        else {
            var _a = attributeDescriptor, namespace = _a.namespace, name_1 = _a.name, value = _a.value;
            if (namespace === undefined) {
                properties[name_1] = value;
            }
            else if (namespace === context.eventNamespaceName) {
                eventStreams[name_1] = value;
            }
            else {
                throw new Error("Unsupported component namespace '" + namespace + "'");
            }
        }
    }); };
    processAttributes(attributes);
    return function (scope) {
        var createdEventStreams = [];
        var nodeDescriptor = ComponentFactory({
            properties: properties,
            eventStreams: eventStreams,
            children: children,
            createEventStream: function () {
                var eventStream = eventing_1.createEventStream();
                createdEventStreams.push(eventStream);
                return eventStream;
            },
            attachEventStream: function (to$, from$) {
                eventing_1.attachEventStream(to$, from$.until(scope.destroy$));
            }
        })(scope);
        return nodeDescriptor;
    };
}
exports.component = component;
