import { Attributes, InitializeNode, NodeDescriptor, DomContainerNode } from './node';
import { StreamDomContext, StreamDomScope } from '../index';
export declare type InitializeElementNode = (scope: StreamDomScope) => ElementNodeDescriptor;
export interface ElementDetails {
    namespaceName?: string;
    attributes?: Attributes;
    children?: InitializeNode[];
}
export declare function element(context: StreamDomContext, name: string, {namespaceName, attributes, children}?: ElementDetails): InitializeElementNode;
export declare function text(context: StreamDomContext, str: string): InitializeNode;
export declare abstract class DomNodeDescriptor implements NodeDescriptor {
    domNode: Node;
    constructor(domNode: Node);
    readonly abstract type: string;
    insert(domParentNode: DomContainerNode, domBeforeNode?: Node): void;
    remove(): void;
}
export declare class ElementNodeDescriptor extends DomNodeDescriptor {
    childDescriptors: NodeDescriptor[];
    readonly type: string;
    constructor({domNode, childDescriptors}: {
        domNode: Element;
        childDescriptors: NodeDescriptor[];
    });
}
export declare class TextNodeDescriptor extends DomNodeDescriptor {
    readonly type: string;
}
