import { StreamDomScope } from '../index';
import { Stream } from 'most';
export declare type DomContainerNode = HTMLElement | DocumentFragment;
export interface NodeDescriptor {
    type: string;
    insert(domParentNode: DomContainerNode, domBeforeNode?: Node): void;
    remove(): void;
}
export interface InitializeNode {
    (scope: StreamDomScope): NodeDescriptor;
}
export declare type ChildDeclaration = InitializeNode | InitializeNode[];
export interface Attribute {
    namespace?: string;
    name: string;
    value: Stream<any> | any;
}
export declare type Attributes = Array<Attribute | Attribute[]>;
