"use strict";
function initializeChildren(children, scope) {
    return children.reduce(reduceChildren, []);
    function reduceChildren(descriptors, childInitOrArray) {
        if (Array.isArray(childInitOrArray)) {
            childInitOrArray.reduce(reduceChildren, descriptors);
        }
        else if (typeof childInitOrArray === 'function') {
            descriptors.push(childInitOrArray(scope));
        }
        else {
            throw new Error("Unexpected child type " + typeof childInitOrArray);
        }
        return descriptors;
    }
}
exports.initializeChildren = initializeChildren;
